//////////////////////////////////////////////////////////////////////////////
// Filename:          E:\ECE532\v2r/drivers/position_detector_v1_00_a/src/position_detector.h
// Version:           1.00.a
// Description:       position_detector Driver Header File
// Date:              Sat Mar 19 19:20:20 2011 (by Create and Import Peripheral Wizard)
//////////////////////////////////////////////////////////////////////////////

#ifndef POSITION_DETECTOR_H
#define POSITION_DETECTOR_H

/***************************** Include Files *******************************/

#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"

/************************** Constant Definitions ***************************/


/**
 * User Logic Slave Space Offsets
 * -- SLV_REG0 : user logic slave module register 0
 * -- SLV_REG1 : user logic slave module register 1
 * -- SLV_REG2 : user logic slave module register 2
 * -- SLV_REG3 : user logic slave module register 3
 * -- SLV_REG4 : user logic slave module register 4
 * -- SLV_REG5 : user logic slave module register 5
 * -- SLV_REG6 : user logic slave module register 6
 * -- SLV_REG7 : user logic slave module register 7
 * -- SLV_REG8 : user logic slave module register 8
 * -- SLV_REG9 : user logic slave module register 9
 * -- SLV_REG10 : user logic slave module register 10
 * -- SLV_REG11 : user logic slave module register 11
 * -- SLV_REG12 : user logic slave module register 12
 * -- SLV_REG13 : user logic slave module register 13
 * -- SLV_REG14 : user logic slave module register 14
 * -- SLV_REG15 : user logic slave module register 15
 * -- SLV_REG16 : user logic slave module register 16
 * -- SLV_REG17 : user logic slave module register 17
 * -- SLV_REG18 : user logic slave module register 18
 * -- SLV_REG19 : user logic slave module register 19
 * -- SLV_REG20 : user logic slave module register 20
 * -- SLV_REG21 : user logic slave module register 21
 * -- SLV_REG22 : user logic slave module register 22
 * -- SLV_REG23 : user logic slave module register 23
 */
#define POSITION_DETECTOR_USER_SLV_SPACE_OFFSET (0x00000000)
#define POSITION_DETECTOR_SLV_REG0_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000000)
#define POSITION_DETECTOR_SLV_REG1_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000004)
#define POSITION_DETECTOR_SLV_REG2_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000008)
#define POSITION_DETECTOR_SLV_REG3_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x0000000C)
#define POSITION_DETECTOR_SLV_REG4_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000010)
#define POSITION_DETECTOR_SLV_REG5_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000014)
#define POSITION_DETECTOR_SLV_REG6_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000018)
#define POSITION_DETECTOR_SLV_REG7_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x0000001C)
#define POSITION_DETECTOR_SLV_REG8_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000020)
#define POSITION_DETECTOR_SLV_REG9_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000024)
#define POSITION_DETECTOR_SLV_REG10_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000028)
#define POSITION_DETECTOR_SLV_REG11_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x0000002C)
#define POSITION_DETECTOR_SLV_REG12_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000030)
#define POSITION_DETECTOR_SLV_REG13_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000034)
#define POSITION_DETECTOR_SLV_REG14_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000038)
#define POSITION_DETECTOR_SLV_REG15_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x0000003C)
#define POSITION_DETECTOR_SLV_REG16_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000040)
#define POSITION_DETECTOR_SLV_REG17_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000044)
#define POSITION_DETECTOR_SLV_REG18_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000048)
#define POSITION_DETECTOR_SLV_REG19_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x0000004C)
#define POSITION_DETECTOR_SLV_REG20_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000050)
#define POSITION_DETECTOR_SLV_REG21_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000054)
#define POSITION_DETECTOR_SLV_REG22_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x00000058)
#define POSITION_DETECTOR_SLV_REG23_OFFSET (POSITION_DETECTOR_USER_SLV_SPACE_OFFSET + 0x0000005C)

/**
 * User Logic Master Space Offsets
 * -- MST_CNTL_REG : user logic master module control register
 * -- MST_STAT_REG : user logic master module status register
 * -- MST_ADDR_REG : user logic master module address register
 * -- MST_BE_REG   : user logic master module byte enable register
 * -- MST_LEN_REG  : user logic master module length (data transfer in bytes) register
 * -- MST_GO_PORT  : user logic master module go bit (to start master operation)
 */
#define POSITION_DETECTOR_USER_MST_SPACE_OFFSET (0x00000100)
#define POSITION_DETECTOR_MST_CNTL_REG_OFFSET (POSITION_DETECTOR_USER_MST_SPACE_OFFSET + 0x00000000)
#define POSITION_DETECTOR_MST_STAT_REG_OFFSET (POSITION_DETECTOR_USER_MST_SPACE_OFFSET + 0x00000001)
#define POSITION_DETECTOR_MST_ADDR_REG_OFFSET (POSITION_DETECTOR_USER_MST_SPACE_OFFSET + 0x00000004)
#define POSITION_DETECTOR_MST_BE_REG_OFFSET (POSITION_DETECTOR_USER_MST_SPACE_OFFSET + 0x00000008)
#define POSITION_DETECTOR_MST_LEN_REG_OFFSET (POSITION_DETECTOR_USER_MST_SPACE_OFFSET + 0x0000000C)
#define POSITION_DETECTOR_MST_GO_PORT_OFFSET (POSITION_DETECTOR_USER_MST_SPACE_OFFSET + 0x0000000F)

/**
 * User Logic Master Module Masks
 * -- MST_RD_MASK   : user logic master read request control
 * -- MST_WR_MASK   : user logic master write request control
 * -- MST_BL_MASK   : user logic master bus lock control
 * -- MST_BRST_MASK : user logic master burst assertion control
 * -- MST_DONE_MASK : user logic master transfer done status
 * -- MST_BSY_MASK  : user logic master busy status
 * -- MST_BRRD      : user logic master burst read request
 * -- MST_BRWR      : user logic master burst write request
 * -- MST_SGRD      : user logic master single read request
 * -- MST_SGWR      : user logic master single write request
 * -- MST_START     : user logic master to start transfer
 */
#define MST_RD_MASK (0x80000000UL)
#define MST_WR_MASK (0x40000000UL)
#define MST_BL_MASK (0x20000000UL)
#define MST_BRST_MASK (0x10000000UL)
#define MST_DONE_MASK (0x00800000UL)
#define MST_BSY_MASK (0x00400000UL)
#define MST_BRRD (0x90)
#define MST_BRWR (0x50)
#define MST_SGRD (0x80)
#define MST_SGWR (0x40)
#define MST_START (0x0A)

/**************************** Type Definitions *****************************/


/***************** Macros (Inline Functions) Definitions *******************/

/**
 *
 * Write a value to a POSITION_DETECTOR register. A 32 bit write is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is written.
 *
 * @param   BaseAddress is the base address of the POSITION_DETECTOR device.
 * @param   RegOffset is the register offset from the base to write to.
 * @param   Data is the data written to the register.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void POSITION_DETECTOR_mWriteReg(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Data)
 *
 */
#define POSITION_DETECTOR_mWriteReg(BaseAddress, RegOffset, Data) \
 	XIo_Out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

/**
 *
 * Read a value from a POSITION_DETECTOR register. A 32 bit read is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is read from the register. The most significant data
 * will be read as 0.
 *
 * @param   BaseAddress is the base address of the POSITION_DETECTOR device.
 * @param   RegOffset is the register offset from the base to write to.
 *
 * @return  Data is the data from the register.
 *
 * @note
 * C-style signature:
 * 	Xuint32 POSITION_DETECTOR_mReadReg(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define POSITION_DETECTOR_mReadReg(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (RegOffset))


/**
 *
 * Write/Read 32 bit value to/from POSITION_DETECTOR user logic slave registers.
 *
 * @param   BaseAddress is the base address of the POSITION_DETECTOR device.
 * @param   RegOffset is the offset from the slave register to write to or read from.
 * @param   Value is the data written to the register.
 *
 * @return  Data is the data from the user logic slave register.
 *
 * @note
 * C-style signature:
 * 	void POSITION_DETECTOR_mWriteSlaveRegn(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Value)
 * 	Xuint32 POSITION_DETECTOR_mReadSlaveRegn(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define POSITION_DETECTOR_mWriteSlaveReg0(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG0_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg1(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG1_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg2(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG2_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg3(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG3_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg4(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG4_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg5(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG5_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg6(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG6_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg7(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG7_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg8(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG8_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg9(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG9_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg10(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG10_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg11(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG11_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg12(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG12_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg13(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG13_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg14(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG14_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg15(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG15_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg16(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG16_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg17(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG17_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg18(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG18_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg19(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG19_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg20(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG20_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg21(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG21_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg22(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG22_OFFSET) + (RegOffset), (Xuint32)(Value))
#define POSITION_DETECTOR_mWriteSlaveReg23(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (POSITION_DETECTOR_SLV_REG23_OFFSET) + (RegOffset), (Xuint32)(Value))

#define POSITION_DETECTOR_mReadSlaveReg0(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG0_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg1(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG1_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg2(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG2_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg3(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG3_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg4(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG4_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg5(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG5_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg6(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG6_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg7(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG7_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg8(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG8_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg9(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG9_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg10(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG10_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg11(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG11_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg12(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG12_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg13(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG13_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg14(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG14_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg15(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG15_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg16(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG16_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg17(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG17_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg18(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG18_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg19(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG19_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg20(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG20_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg21(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG21_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg22(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG22_OFFSET) + (RegOffset))
#define POSITION_DETECTOR_mReadSlaveReg23(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (POSITION_DETECTOR_SLV_REG23_OFFSET) + (RegOffset))

/**
 *
 * Check status of POSITION_DETECTOR user logic master module.
 *
 * @param   BaseAddress is the base address of the POSITION_DETECTOR device.
 *
 * @return  Status is the result of status checking.
 *
 * @note
 * C-style signature:
 * 	bool POSITION_DETECTOR_mMasterDone(Xuint32 BaseAddress)
 * 	bool POSITION_DETECTOR_mMasterBusy(Xuint32 BaseAddress)
 * 	bool POSITION_DETECTOR_mMasterError(Xuint32 BaseAddress)
 * 	bool POSITION_DETECTOR_mMasterTimeout(Xuint32 BaseAddress)
 *
 */
#define POSITION_DETECTOR_mMasterDone(BaseAddress) \
 	((((Xuint32) XIo_In8((BaseAddress)+(POSITION_DETECTOR_MST_STAT_REG_OFFSET)))<<16 & MST_DONE_MASK) == MST_DONE_MASK)
#define POSITION_DETECTOR_mMasterBusy(BaseAddress) \
 	((((Xuint32) XIo_In8((BaseAddress)+(POSITION_DETECTOR_MST_STAT_REG_OFFSET)))<<16 & MST_BUSY_MASK) == MST_BUSY_MASK)
#define POSITION_DETECTOR_mMasterError(BaseAddress) \
 	((((Xuint32) XIo_In8((BaseAddress)+(POSITION_DETECTOR_MST_STAT_REG_OFFSET)))<<16 & MST_ERROR_MASK) == MST_ERROR_MASK)
#define POSITION_DETECTOR_mMasterTimeout(BaseAddress) \
 	((((Xuint32) XIo_In8((BaseAddress)+(POSITION_DETECTOR_MST_STAT_REG_OFFSET)))<<16 & MST_TIMEOUT_MASK) == MST_TIMEOUT_MASK)

/************************** Function Prototypes ****************************/


/**
 *
 * User logic master module to send/receive bytes to/from remote system memory.
 * While sending, the bytes are read from user logic local FIFO and write to remote memory.
 * While receiving, the bytes are read from remote memory and write to user logic local FIFO.
 *
 * @param   BaseAddress is the base address of the POSITION_DETECTOR device.
 * @param   DstAddress is the destination memory address from/to which the data will be fetched/stored.
 * @param   Size is the number of bytes to be sent.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void POSITION_DETECTOR_MasterSendByte(Xuint32 BaseAddress, Xuint32 DstAddress, int Size);
void POSITION_DETECTOR_MasterRecvByte(Xuint32 BaseAddress, Xuint32 DstAddress, int Size);

/**
 *
 * Run a self-test on the driver/device. Note this may be a destructive test if
 * resets of the device are performed.
 *
 * If the hardware system is not built correctly, this function may never
 * return to the caller.
 *
 * @param   baseaddr_p is the base address of the POSITION_DETECTOR instance to be worked on.
 *
 * @return
 *
 *    - XST_SUCCESS   if all self-test code passed
 *    - XST_FAILURE   if any self-test code failed
 *
 * @note    Caching must be turned off for this function to work.
 * @note    Self test may fail if data memory and device are not on the same bus.
 *
 */
XStatus POSITION_DETECTOR_SelfTest(void * baseaddr_p);

#endif // POSITION_DETECTOR_H
