-------------------------------------------------------------------------------
-- system_stub.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity system_stub is
  port (
    sys_clk_pin : in std_logic;
    sys_rst_pin : in std_logic;
    LLC_CLOCK_pin : in std_logic;
    YCrCb_in_pin : in std_logic_vector(9 downto 2);
    IIC_Scl_pin : inout std_logic;
    IIC_Sda_pin : inout std_logic;
    VGA_VSYNCH_pin : out std_logic;
    VGA_HSYNCH_pin : out std_logic;
    VGA_OUT_BLANK_Z_pin : out std_logic;
    VGA_COMP_SYNCH_pin : out std_logic;
    VGA_PIXEL_CLOCK_pin : out std_logic;
    VGA_OUT_RED_pin : out std_logic_vector(5 downto 0);
    VGA_OUT_GREEN_pin : out std_logic_vector(5 downto 0);
    VGA_OUT_BLUE_pin : out std_logic_vector(5 downto 0);
    fpga_0_RS232_Uart_1_RX_pin : in std_logic;
    fpga_0_RS232_Uart_1_TX_pin : out std_logic;
    LED_pin : out std_logic_vector(3 downto 0);
    DIP_SW_pin : in std_logic_vector(3 downto 0);
    fpga_0_DDR_SDRAM_DDR_Clk_pin : out std_logic_vector(2 downto 0);
    fpga_0_DDR_SDRAM_DDR_Clk_n_pin : out std_logic_vector(2 downto 0);
    fpga_0_DDR_SDRAM_DDR_Addr_pin : out std_logic_vector(12 downto 0);
    fpga_0_DDR_SDRAM_DDR_BankAddr_pin : out std_logic_vector(1 downto 0);
    fpga_0_DDR_SDRAM_DDR_CAS_n_pin : out std_logic;
    fpga_0_DDR_SDRAM_DDR_CE_pin : out std_logic_vector(1 downto 0);
    fpga_0_DDR_SDRAM_DDR_CS_n_pin : out std_logic_vector(1 downto 0);
    fpga_0_DDR_SDRAM_DDR_RAS_n_pin : out std_logic;
    fpga_0_DDR_SDRAM_DDR_WE_n_pin : out std_logic;
    fpga_0_DDR_SDRAM_DDR_DM_pin : out std_logic_vector(7 downto 0);
    fpga_0_DDR_SDRAM_DDR_DQS : inout std_logic_vector(7 downto 0);
    fpga_0_DDR_SDRAM_DDR_DQ : inout std_logic_vector(63 downto 0);
    video_to_ram_0_i_DBG_new_line_pin : in std_logic;
    fpga_0_net_gnd_pin : out std_logic;
    fpga_0_net_gnd_1_pin : out std_logic;
    fpga_0_net_gnd_2_pin : out std_logic;
    fpga_0_net_gnd_3_pin : out std_logic;
    fpga_0_net_gnd_4_pin : out std_logic;
    fpga_0_net_gnd_5_pin : out std_logic;
    fpga_0_net_gnd_6_pin : out std_logic;
    vid_dec_reset_in : in std_logic
  );
end system_stub;

architecture STRUCTURE of system_stub is

  component system is
    port (
      sys_clk_pin : in std_logic;
      sys_rst_pin : in std_logic;
      LLC_CLOCK_pin : in std_logic;
      YCrCb_in_pin : in std_logic_vector(9 downto 2);
      IIC_Scl_pin : inout std_logic;
      IIC_Sda_pin : inout std_logic;
      VGA_VSYNCH_pin : out std_logic;
      VGA_HSYNCH_pin : out std_logic;
      VGA_OUT_BLANK_Z_pin : out std_logic;
      VGA_COMP_SYNCH_pin : out std_logic;
      VGA_PIXEL_CLOCK_pin : out std_logic;
      VGA_OUT_RED_pin : out std_logic_vector(5 downto 0);
      VGA_OUT_GREEN_pin : out std_logic_vector(5 downto 0);
      VGA_OUT_BLUE_pin : out std_logic_vector(5 downto 0);
      fpga_0_RS232_Uart_1_RX_pin : in std_logic;
      fpga_0_RS232_Uart_1_TX_pin : out std_logic;
      LED_pin : out std_logic_vector(3 downto 0);
      DIP_SW_pin : in std_logic_vector(3 downto 0);
      fpga_0_DDR_SDRAM_DDR_Clk_pin : out std_logic_vector(2 downto 0);
      fpga_0_DDR_SDRAM_DDR_Clk_n_pin : out std_logic_vector(2 downto 0);
      fpga_0_DDR_SDRAM_DDR_Addr_pin : out std_logic_vector(12 downto 0);
      fpga_0_DDR_SDRAM_DDR_BankAddr_pin : out std_logic_vector(1 downto 0);
      fpga_0_DDR_SDRAM_DDR_CAS_n_pin : out std_logic;
      fpga_0_DDR_SDRAM_DDR_CE_pin : out std_logic_vector(1 downto 0);
      fpga_0_DDR_SDRAM_DDR_CS_n_pin : out std_logic_vector(1 downto 0);
      fpga_0_DDR_SDRAM_DDR_RAS_n_pin : out std_logic;
      fpga_0_DDR_SDRAM_DDR_WE_n_pin : out std_logic;
      fpga_0_DDR_SDRAM_DDR_DM_pin : out std_logic_vector(7 downto 0);
      fpga_0_DDR_SDRAM_DDR_DQS : inout std_logic_vector(7 downto 0);
      fpga_0_DDR_SDRAM_DDR_DQ : inout std_logic_vector(63 downto 0);
      video_to_ram_0_i_DBG_new_line_pin : in std_logic;
      fpga_0_net_gnd_pin : out std_logic;
      fpga_0_net_gnd_1_pin : out std_logic;
      fpga_0_net_gnd_2_pin : out std_logic;
      fpga_0_net_gnd_3_pin : out std_logic;
      fpga_0_net_gnd_4_pin : out std_logic;
      fpga_0_net_gnd_5_pin : out std_logic;
      fpga_0_net_gnd_6_pin : out std_logic;
      vid_dec_reset_in : in std_logic
    );
  end component;

begin

  system_i : system
    port map (
      sys_clk_pin => sys_clk_pin,
      sys_rst_pin => sys_rst_pin,
      LLC_CLOCK_pin => LLC_CLOCK_pin,
      YCrCb_in_pin => YCrCb_in_pin,
      IIC_Scl_pin => IIC_Scl_pin,
      IIC_Sda_pin => IIC_Sda_pin,
      VGA_VSYNCH_pin => VGA_VSYNCH_pin,
      VGA_HSYNCH_pin => VGA_HSYNCH_pin,
      VGA_OUT_BLANK_Z_pin => VGA_OUT_BLANK_Z_pin,
      VGA_COMP_SYNCH_pin => VGA_COMP_SYNCH_pin,
      VGA_PIXEL_CLOCK_pin => VGA_PIXEL_CLOCK_pin,
      VGA_OUT_RED_pin => VGA_OUT_RED_pin,
      VGA_OUT_GREEN_pin => VGA_OUT_GREEN_pin,
      VGA_OUT_BLUE_pin => VGA_OUT_BLUE_pin,
      fpga_0_RS232_Uart_1_RX_pin => fpga_0_RS232_Uart_1_RX_pin,
      fpga_0_RS232_Uart_1_TX_pin => fpga_0_RS232_Uart_1_TX_pin,
      LED_pin => LED_pin,
      DIP_SW_pin => DIP_SW_pin,
      fpga_0_DDR_SDRAM_DDR_Clk_pin => fpga_0_DDR_SDRAM_DDR_Clk_pin,
      fpga_0_DDR_SDRAM_DDR_Clk_n_pin => fpga_0_DDR_SDRAM_DDR_Clk_n_pin,
      fpga_0_DDR_SDRAM_DDR_Addr_pin => fpga_0_DDR_SDRAM_DDR_Addr_pin,
      fpga_0_DDR_SDRAM_DDR_BankAddr_pin => fpga_0_DDR_SDRAM_DDR_BankAddr_pin,
      fpga_0_DDR_SDRAM_DDR_CAS_n_pin => fpga_0_DDR_SDRAM_DDR_CAS_n_pin,
      fpga_0_DDR_SDRAM_DDR_CE_pin => fpga_0_DDR_SDRAM_DDR_CE_pin,
      fpga_0_DDR_SDRAM_DDR_CS_n_pin => fpga_0_DDR_SDRAM_DDR_CS_n_pin,
      fpga_0_DDR_SDRAM_DDR_RAS_n_pin => fpga_0_DDR_SDRAM_DDR_RAS_n_pin,
      fpga_0_DDR_SDRAM_DDR_WE_n_pin => fpga_0_DDR_SDRAM_DDR_WE_n_pin,
      fpga_0_DDR_SDRAM_DDR_DM_pin => fpga_0_DDR_SDRAM_DDR_DM_pin,
      fpga_0_DDR_SDRAM_DDR_DQS => fpga_0_DDR_SDRAM_DDR_DQS,
      fpga_0_DDR_SDRAM_DDR_DQ => fpga_0_DDR_SDRAM_DDR_DQ,
      video_to_ram_0_i_DBG_new_line_pin => video_to_ram_0_i_DBG_new_line_pin,
      fpga_0_net_gnd_pin => fpga_0_net_gnd_pin,
      fpga_0_net_gnd_1_pin => fpga_0_net_gnd_1_pin,
      fpga_0_net_gnd_2_pin => fpga_0_net_gnd_2_pin,
      fpga_0_net_gnd_3_pin => fpga_0_net_gnd_3_pin,
      fpga_0_net_gnd_4_pin => fpga_0_net_gnd_4_pin,
      fpga_0_net_gnd_5_pin => fpga_0_net_gnd_5_pin,
      fpga_0_net_gnd_6_pin => fpga_0_net_gnd_6_pin,
      vid_dec_reset_in => vid_dec_reset_in
    );

end architecture STRUCTURE;

