//Define the screen resolution
#define MAX_SIZE 50

struct Point
{
   int x, y;
};

struct line {
    struct Point p1, p2;
};

struct Bullet
{
   struct Point start_loc, velocity;	
};

struct Gun
{
   struct Point start_loc, velocity;
   int no, lives;
	int is_triggered;
};

int size_bullets;
struct Bullet bullets[MAX_SIZE];

void Init_b()
{
	 size_bullets = 0;
}

int add_bullet(struct Point p, struct Point speed)
{
	 if(size_bullets < MAX_SIZE-1)
	 {
		  bullets[size_bullets].start_loc.x = p.x;
		  bullets[size_bullets].start_loc.y = p.y;
		  bullets[size_bullets].velocity.x = speed.x;
		  bullets[size_bullets].velocity.y = speed.y;
		  size_bullets++;
		  return 1;
	 }
	 return 0;
}

int delete_b(int index)
{
	 int i;
	 
	 if(size_bullets > 0 && index < size_bullets)
	 {
		 for(i = index; i <= size_bullets-2; i++)
		 {
			  bullets[i].start_loc = bullets[i+1].start_loc;			  
			  bullets[i].velocity = bullets[i+1].velocity;			  
		 }
		 size_bullets--;
		 return 1;
	 }
	 return 0;
}

struct Bullet get(int index)
{
	 if(index < size_bullets)
	 {		  
		  return bullets[index];			  
	 }
    struct Bullet invalid = {{-1, -1}, {-1, -1}};	 
	 return invalid;
}

int set(int index, struct Point p, struct Point speed)
{
	 if(index < size_bullets)
	 {
		  bullets[index].start_loc.x = p.x;
		  bullets[index].start_loc.y = p.y;
		  bullets[index].velocity.x = speed.x;
		  bullets[index].velocity.y = speed.y;
		  return 1;
	 }
	 return 0;
}	

int remove_bullets(int bullets[MAX_SIZE], int size)
{
   int k=0;
   for(k=0; k<size; k++)
	   delete_b(bullets[k]);
}

int turn(struct Point p, struct Point q, struct Point r) {
    long result = (r.x - q.x) * (p.y - q.y) - (r.y - q.y) * (p.x - q.x);
    if (result < 0) return -1; // P->Q->R is a RIGHT TURN
    if (result > 0) return 1; // P->Q->R is a LEFT TURN
    return 0; // P->Q->R is a STRAIGHT LINE, i.e. P, Q, R are COLLINEAR
}

// Note: in some application, we change the relational test below
// from > 0 to >= 0 to accept collinear Points
int ccw(struct Point p, struct Point q, struct Point r) { return turn(p, q, r); }

int intersect(struct line line1, struct line line2) {
    return
        ((ccw(line1.p1, line1.p2, line2.p1) * ccw(line1.p1, line1.p2, line2.p2)) < 0)
        &&
        ((ccw(line2.p1, line2.p2, line1.p1) * ccw(line2.p1, line2.p2, line1.p2)) < 0);
}
