/* $Id: xtft_sinit.c,v 1.1.2.2 2008/06/16 08:49:16 suneelg Exp $ */
/*****************************************************************************
*
*	XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
*	AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
*	SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE,
*	OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
*	APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
*	THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
*	AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
*	FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
*	WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
*	IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
*	REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
*	INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*	FOR A PARTICULAR PURPOSE.
*
*	(c) Copyright 2008 Xilinx Inc.
*	All rights reserved.
*
*****************************************************************************/
/****************************************************************************/
/**
*
* @file xtft_sinit.c
*
* This file defines the implementation of Tft device static initialization
* functionality.
*
*
* <pre>
* MODIFICATION HISTORY:
*
* Ver    Who   Date      Changes
* -----  ----  --------  -----------------------------------------------
* 1.00a  sg    03/24/08  First release
* </pre>
*
*****************************************************************************/

/***************************** Include Files ********************************/
#include "xparameters.h"
#include "xtft.h"

/************************** Constant Definitions ****************************/

/**************************** Type Definitions ******************************/

/***************** Macros (Inline Functions) Definitions ********************/

/************************** Function Prototypes ****************************/

/************************** Variable Definitions ****************************/
extern XTft_Config XTft_ConfigTable[];

/************************** Function Definitions ****************************/
/****************************************************************************/
/**
*
* This function obtains the Configuration pointer of the device whose ID
* is being passed as the parameter to the function.
*
* @param	DeviceId is the unique number of the device.
*
* @return	Configuration pointer of the Device whose ID is given.
*
* @note		None.
*
*****************************************************************************/
XTft_Config *XTft_LookupConfig(u16 DeviceId)
{
	XTft_Config *CfgPtr = NULL;
	u32 Index;

	/*
	 * Based on the number of instances of tft defined, compare
	 * the given Device ID with the ID of each instance and get
	 * the configptr of the matched instance.
	 */
	for (Index=0; Index < XPAR_XTFT_NUM_INSTANCES; Index++) {
		if (XTft_ConfigTable[Index].DeviceId == DeviceId) {
			CfgPtr = &XTft_ConfigTable[Index];
		}
	}

	return CfgPtr;
}

